/****************************************************************************/
/*                         SQL Server Internals v3                          */
/*                           Training Materials                             */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                         Diagnostics Scripts                              */
/*                        Schedulers Statistics                             */
/****************************************************************************/


-- Checks that schedulers evenly divided across the nodes

select 
	parent_node_id
	,scheduler_id
	,status
	,current_tasks_count
	,runnable_tasks_count
from sys.dm_os_schedulers
where 
	status = 'VISIBLE ONLINE'
order by 
	parent_node_id
	,scheduler_id;

select 
	parent_node_id
	,count(*) as [Schedulers]
	,sum(current_tasks_count) as [Current]
	,sum(runnable_tasks_count) as [Runnable]
from sys.dm_os_schedulers
where status = 'VISIBLE ONLINE'
group by parent_node_id;
