/****************************************************************************/
/*                         SQL Server Internals v3                          */
/*                           Training Materials                             */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                         Diagnostics Scripts                              */
/*                        Unindexed Foreign Keys                            */
/****************************************************************************/


select * 
from sys.foreign_keys fk with (nolock)
where
	exists
	(
		select * 
		from sys.foreign_key_columns fkc with (nolock)
		where 
			fkc.constraint_object_id = fk.object_id and
			not exists
			(
				select *
				from sys.index_columns ic with (nolock)
				where 
					ic.object_id = fkc.parent_object_id and 
					ic.column_id = fkc.parent_column_id and 
					ic.key_ordinal = fkc.constraint_column_id

			)
	)
option (recompile, maxdop 1);
go
