/****************************************************************************/
/*                         SQL Server Internals v3                          */
/*                           Training Materials                             */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Locking and Blocking                              */
/*                     Lock Escalation (Session 1)                          */
/****************************************************************************/

use SQLServerInternals
go

set nocount on
go


set transaction isolation level read uncommitted
begin tran
	update Delivery.Orders
	set OrderStatusId = 1
	where 
		OrderId in 
		(
			select top 10000 OrderId -- Change to 10000 to trigger lock escalation
			from Delivery.Orders
			order by OrderId
		)

	select * from sys.dm_tran_locks where request_session_id = @@SPID -- and resource_type <> 'KEY'
	-- Run session 2 code
rollback