/****************************************************************************/
/*                         SQL Server Internals v3                          */
/*                           Training Materials                             */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Locking and Blocking                              */
/*                        Snapshot (Session 1)                              */
/****************************************************************************/

set nocount on 
go

use master
go

alter database SQLServerInternals set allow_snapshot_isolation on 
go

use SQLServerInternals
go

set transaction isolation level read uncommitted
begin tran
	update dbo.SmallRow set CharField = 'Placeholer' where ID = 100
	select * from sys.dm_tran_locks where request_session_id = @@SPID
	-- Run session 2 code
commit
go

if exists(
	select *
	from sys.tables t join sys.schemas s on
		t.schema_id = s.schema_id
	where
		t.name = 'Colors' and s.name = 'dbo'
)
	drop table dbo.Colors
go

create table dbo.Colors
(
	ID int not null,
	Color varchar(10) not null    
)
go

insert into dbo.Colors(ID,Color) 
values(1,'White'),(2,'Black')
go

set transaction isolation level read committed
--set transaction isolation level snapshot
begin tran
	update dbo.Colors
	set Color = 'White'
	where Color = 'Black'
	-- Run session 2 code
commit
go

select * from dbo.Colors