/****************************************************************************/
/*                         SQL Server Internals v3                          */
/*                           Training Materials                             */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Locking and Blocking                              */
/*                         Version Store Usage                              */
/****************************************************************************/

use SQLServerInternals
go

set nocount on
go

-- You can enable Snapshot Isolation Level instead
alter database SQLServerInternals set read_committed_snapshot on with rollback immediate
go

-- Monitor Version Store Performance Counters

set transaction isolation level read uncommitted
begin tran
	delete from dbo.LargeRow

rollback
go

-- Cleanup
alter database SQLServerInternals set read_committed_snapshot off with rollback immediate
go
