/****************************************************************************/
/*                         SQL Server Internals v3                          */
/*                           Training Materials                             */
/*                                                                          */
/*                  Written by Dmitri V. Korotkevitch                       */
/*                      http://aboutsqlserver.com                           */
/*                        dk@aboutsqlserver.com                             */
/****************************************************************************/
/*                        Locking and Blocking                              */
/*                 Analyzing Lock Partitioning (Session 1)                  */
/****************************************************************************/

-- You need to have 16 or more schedulers for lock partitioning to be enabled

-- You can artificially change number of cores with undocumented startup flag -P[N] 
-- [N] is number of cores. DO NOT DO THIS IN PRODUCTION!

use SQLServerInternals
go

-- Blocking
alter index PK_Orders on Delivery.Orders rebuild
with (online = on);
go

-- No issues here
alter index PK_Orders on Delivery.Orders rebuild
with 
(
	online = on
	(
		wait_at_low_priority
		(
			max_duration=1 minutes, 
			abort_after_wait=blockers
		)
	)
);


